#!/usr/local/bin/perl

package IPAnalyze::Auth;
use strict;

sub new {
   my $me = shift;
   return bless({}, $me);
}

sub check_credentials {
	my $self = shift;
	my $dbh = shift;
	my $q = shift;

	my @error;

	#get the user login information from the database and prepare it for the session file
	my $luser = $q->param('login_user');
	my $lpass = $q->param('login_passwd');
	#my $redirect = $q->param('redirect');
 
	unless($luser =~ /^[a-z]{3}[a-z0-9]{1,20}$/){
		push @error, 'Username or password is incorrect';
		return(@error)
	}
	my $sql = 'SELECT users.crypt FROM auth.users WHERE users.username = ' . $dbh->quote($luser);
	my $sth = $dbh->prepare($sql);
	$sth->execute();
	my $row = $sth->fetchrow_arrayref;
	if(my $crypt=$row->[0]){
		if(($crypt eq crypt($lpass, $crypt)) && $crypt) {
			if(my $sess_id = $q->cookie('sess_id')){
				my $sql = 'UPDATE auth.users SET users.sess_id = ' . $dbh->quote($sess_id);
				$sql .= ' WHERE users.username = ' . $dbh->quote($luser);
				#warn "sql: $sql\n";
				my $sth = $dbh->prepare($sql);
				$sth->execute();
				return();
			}else{
				push @error, 'sess_id not found in cookie';
				return(@error);
			}
		}else{
			push @error, 'Username or password is incorrect';
			return(@error);
		}
	}else{
		push @error, 'Username or password is incorrect';
		return(@error);	
	}
}

sub get_username {
	my $self = shift;
	my $dbh = shift;
	my $q = shift;

	if(my $sess_id = $q->cookie('sess_id')){
		my $sql = 'SELECT users.username FROM auth.users WHERE users.sess_id = ' . $dbh->quote($sess_id);
		my $sth = $dbh->prepare($sql);
		$sth->execute();
		my $row = $sth->fetchrow_arrayref;
		return($row->[0]);
	}else{
		die "no username found with sess_id $sess_id\n";
	}
}

sub check_access {
	my $self = shift;
	my $dbh = shift;
	my $q = shift;
	my $app = shift || die "check_access syntax err3\n";

	if(my $sess_id=$q->cookie('sess_id')){
		my $sql = "SELECT users.username,${app}.access FROM auth.users,auth.${app}";
		$sql .= " WHERE users.id = ${app}.id AND users.sess_id = " . $dbh->quote($sess_id);
		my $sth = $dbh->prepare($sql);
		$sth->execute();
		my $row = $sth->fetchrow_arrayref;
		if($row->[0]){
			#warn "$sess_id => $row->[0] - $row->[1]\n";
			return($row->[0],$row->[1]);
		}else{
			warn "Session Key invalid: $sess_id\n";
			my @error = ('Session Key is invalid');
			return('','',@error);	
		}
	}else{
		warn "No sess_id found\n";
		my @error = ('No sess_id invalid');
		return('','',@error);	
	}
}

sub manage_cookie {
	my $self = shift;
	my $dbh = shift;
	my $q = shift;
	my $misc = shift;
	
	if(my $sess_id=$q->cookie('sess_id')){
		#warn "sess id: $sess_id\n";
		#print header;
		return(1);
	}else{
		my $random = $misc->get_rand(128); # 1024 bit
		#warn "random: $random\n";
		
		my $cookie = $q->cookie(-name => 'sess_id', -value => $random, -expires => '+180h');
		print $q->header(-cookie=>[$cookie],-expires=>'now');
		return(2);
	}
}

sub logoff_ap {
	my $self = shift;
	my $script = shift;
	my $q = shift;
	my $cookie = $q->cookie(-name => 'sess_id', -value => '', -expires => '-1');
	print $q->header(-expires=>'now', -cookie=>[$cookie]);

print<<LOGOUT;
   <html><head><title>Logout</title></head><body>
	<div align="center">
	<center>
	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" width="38%" id="AutoNumber1" height="231">
    <tr>
    <td width="100%" height="48" bgcolor="#C0C0C0">
    <p align="center"><font color="#0000FF"><b>Logged Out Successfully</b></font></td>
    </tr>
    <tr>
    <td width="100%" height="183" align="center"><b>You have been successfully 
    logged out!</b><p><b>To return to the application click <a href="$script">here</a>.</b></td>
    </tr>
	</table>
	</center>
	</div>
   </body></html>
LOGOUT
}

1;
