#!/usr/bin/perl

package IPanalyze::Misc;
use strict;

sub new {
	my $me = shift;
	return bless({}, $me);
}

sub get_rand {
	my $self = shift;
	my $length = shift || die "getrand synax error\n";
	my($random,$buf,$x);
	my @set = ('A'..'Z', 'a'..'z', '0'..'9', '_', '.');

	
	my $fh = \do{ local *FILE };
	if(open($fh, '/dev/urandom')){
		foreach(1..$length){
			sysread($fh, $buf, 1);
			my $v = ord($buf);
			$x ^= ($v & ~63) >> (rand(7)+1);
			$random .= $set[ ($x ^ ord($buf)) & 63];
		}
		close $fh;
	}else{
		warn "using less secure random\n";
		srand(time() ^($$ + ($$ << 15)));
		foreach(1..$length){
			$random .= $set[ rand(@set) ];
		}
	}
	return($random); 
}

sub show_error {
	my $self = shift;
	my $html_root = shift;
	my ($error_list) = @_;

	my @error = @$error_list;
	my $template = HTML::Template->new(filename => "$html_root/error.html");
	my @loop_data = ();
	while (@error){
		my %row_data;
		$row_data{ERROR_DATA} = shift @error;
		push(@loop_data, \%row_data);
	}
	$template->param(ERROR_LOOP => \@loop_data);
	print $template->output;
	exit;
}


return 1;
