#!/usr/local/bin/perl

# to check that ipanalyze allocations are really what we think they are

use lib ('/export/web/ipanalyze.example.com/data/lib');

use strict;
use DBI;
use IPAnalyze::Misc;
use IPAnalyze::IPmath;
use Net::CIDR::Lite;

my %cfg;
open(CONFIG, '/export/web/ipanalyze.example.com/data/ipanalyze.conf') || die "cannot open ipanalyze.conf: $!\n";
while(<CONFIG>){
   s/^(.*)\s*#.*/$1/;
   next if(/^$/);
   chomp;
   if(/^(\S+)\s*=>\s?(.+)/){
      $cfg{$1} = $2;
   }
}
close CONFIG;

my $misc = IPAnalyze::Misc->new();
my $ipmath = IPAnalyze::IPmath->new();

my $dbh = DBI->connect($cfg{d_dsn}, $cfg{d_dbun}, $cfg{d_dbpw}, {RaiseError => 1});

my $sql = 'SELECT id,name FROM areas';
my $sth = $dbh->prepare($sql);
$sth->execute;
while(my $row=$sth->fetchrow_arrayref){
	my %area = (id => $row->[0], name => $row->[1]);

	my $sqla = 'SELECT id,netblock,cidr,allow_use FROM parent_networks WHERE area = ' . $dbh->quote($area{id});
	my $stha = $dbh->prepare($sqla);
	$stha->execute;
	my ($total,$used,$admin_prohibited);
	while(my $rowa = $stha->fetchrow_arrayref){
		my %parent = (id => $rowa->[0], netblock => $rowa->[1], cidr => $rowa->[2]);

		if($rowa->[3] == 0){
			$admin_prohibited += $ipmath->cidr_check($parent{cidr});
		}else{
			$total += $ipmath->cidr_check($parent{cidr});
		}

		my $sqlb = 'SELECT netblock,cidr FROM data WHERE parent_id = ' . $dbh->quote($parent{id});
		my $sthb = $dbh->prepare($sqlb);
		$sthb->execute;
		while(my $rowb = $sthb->fetchrow_arrayref){
			if($rowa->[3] == 0){
				$admin_prohibited -= $ipmath->cidr_check($rowb->[1]);
			}else{
				$used += $ipmath->cidr_check($rowb->[1]);
			}
		}
	}

	my $diff = ($total - $used);
	print "AREA $area{name} total: $total - used: $used (diff: $diff) - admin_prohibited: $admin_prohibited\n";
}
