#!/usr/local/bin/perl
# 
# to be ran nightly (or more)
# makes sure netids have correct parent ids
# makes sure parents are valid netblock/cdirs
# makes sure parent ids have valid grandparent ids
# makes sure grandparent_ids are valid netblock/cidrs
# check on netids that have parent_id = 0

use lib ('/export/web/ipanalyze.example.com/data/lib');

use strict;
use DBI;
use IPAnalyze::IPmath;
use IPAnalyze::Taint;


my %cfg;
open(CONFIG, '/export/web/ipanalyze.example.com/data/ipanalyze.conf') || die "cannot open ipanalyze.conf: $!\n";
while(<CONFIG>){
   s/^(.*)\s*#.*/$1/;
   next if(/^$/);
   chomp;
   if(/^(\S+)\s*=>\s?(.+)/){
      $cfg{$1} = $2;
   }
}
close CONFIG;

my $dbh = DBI->connect ($cfg{d_dsn}, $cfg{d_dbun}, $cfg{d_dbpw}, {RaiseError => 1});

my $ipmath = IPAnalyze::IPmath->new();
my $taint = IPAnalyze::Taint->new();

my @errors = $taint->taint_parents($dbh,$ipmath);

my @u = $taint->unknown_parents($dbh,$ipmath);
push @errors, @u;

foreach my $error (@errors){
	print "$error\n";
}
